<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import axios from "axios";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";

import Swal from "sweetalert2";
import { loadScript } from "@paypal/paypal-js";
import { trackEventCheckoutInitiated } from "~/utils/trackEvent";

@Component({
  components: {},
})
export default class PaypalHomeComponent extends Vue {
  @Prop()
  productName!: string;

  @Prop()
  totalPrice!: number;

  @Prop()
  payload!: any;

  @Prop()
  refPaypal!: string;

  // mounted() {
  //   setTimeout(() => {
  //     this.setScriptPaypal();
  //   }, 500);
  // }

  // async setScriptPaypal() {
  //   let paypal;
  //   try {
  //     paypal = loadScript({
  //       "client-id": this.publicKeyPaypal,
  //     }).then(() => {
  //       this.setLoaded();
  //     });
  //   } catch (error) {}
  //   this.$store.commit("product/setLoadingPaypal", false);
  // }
  // async setLoaded() {
  //   const that = this;
  //   //@ts-ignore
  //   const paypal: any = window.paypal;
  //   let orderCodePaypal = "";
  //   let paymentMethodId = "";
  //   const domain = window.location.host || "";
  //   const paypalBtnId = document.getElementById(`${that.refPaypal}`);
  //   //@ts-ignore
  //   await window.paypal
  //     .Buttons({
  //       createOrder: async function (data: any, actions: any) {
  //         try {
  //           that.$gtag.event("payment_click_paypal", {
  //             event_category: "click paypal",
  //             event_label: "click paypal",
  //           });
  //           //@ts-ignore
  //           let listCart = JSON.parse(localStorage.getItem("cart"));
  //           let listSelectedProduct = [];
  //           console.log("that.payload :>> ", that.payload);
  //           if (that.payload && that.payload.variantId) {
  //             listSelectedProduct.push({
  //               variantSellerId: that.payload.variantId,
  //               quantity: parseInt(that.payload.quantity),
  //             });
  //           } else {
  //             if (listCart.length) {
  //               listSelectedProduct = listCart.map((cart: any) => ({
  //                 variantSellerId: cart._id,
  //                 quantity: parseInt(cart.quantity),
  //               }));
  //             }
  //           }
  //           // const listSelectedProduct = [
  //           //   {
  //           //     // productId: that.productId,
  //           //     variantSellerId: that.payload.variantId,
  //           //     quantity: parseInt(that.payload.quantity),
  //           //   },
  //           // ];
  //           trackEventCheckoutInitiated(that);
  //           that.$gtag.event("form_submissions", {
  //             value: `${that.productName || ""} ${that.totalPrice || 0}`,
  //             currency: "USD",
  //           });
  //           const body = {
  //             listSelectedProduct,
  //             countryIp: that.myIp.countryCode,
  //           };
  //           const query = that.$store.state.sitePage.utm || {};
  //           const response = await that.$api.cart.paypalCreateOrderDirect(
  //             body,
  //             domain,
  //             query
  //           );
  //           if (response && response.data) {
  //             paymentMethodId = response.data.paymentMethodId;
  //             orderCodePaypal = response.data.orderCode;
  //             return response.data.id;
  //           }
  //         } catch (error) {
  //           that.$gtag.event("purchase fail", {
  //             value: `${that.productName || ""} ${that.totalPrice || 0}`,
  //             currency: "USD",
  //             event_label: "fail paypal",
  //           });
  //           apiErrorHandler(error, that);
  //         }
  //       },
  //       onApprove: async function (data: any, actions: any) {
  //         const { paymentID, payerID } = data;
  //         if (!paymentID || !payerID || !paymentMethodId) return;
  //         const response = await that.$api.cart.completePaypalPayment({
  //           paymentMethodId,
  //           paymentID,
  //           payerID,
  //         });
  //         if (response.data) {
  //           that.$router.push(
  //             `/order-success?email=${
  //               response.data.email
  //             }&order_code=${response.data.orderCode.replace("#", "")}`
  //           );
  //         }
  //       },
  //       //@ts-ignore
  //       onCancel: async function (isFail?: boolean) {
  //         Swal.fire({
  //           title: `${that.$language.failed}`,
  //           text: `${that.$language.cancelSuccessfully}`,
  //           icon: "error",
  //           confirmButtonColor: "#FF5252",
  //           confirmButtonText: "Agree",
  //         });
  //         that.$gtag.event("cancel_click_paypal", {
  //           event_category: "click cancel paypal",
  //           event_label: "click cancel paypal",
  //         });
  //         that.onDeleteOrder(orderCodePaypal);
  //       },
  //       //@ts-ignore
  //       fundingSource: that.enableCardPaypal
  //         ? undefined
  //         : paypal.FUNDING.PAYPAL,
  //       clientId: that.publicKeyPaypal,
  //     })
  //     //@ts-ignore
  //     .render(paypalBtnId);
  // }
  async onDeleteOrder(orderCodePaypal: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      await this.$api.order.deleteOrder(orderCodePaypal);
    } catch (error) {}
  }

  get $language() {
    return this.$store.state.product.language;
  }

  get loadingPaypal() {
    return this.$store.state.product.loadingPaypal;
  }

  get publicKeyPaypal() {
    return this.$store.state.cart.publicKeyPaypal;
  }

  get myIp() {
    return this.$store.state?.sitePage?.myIp || {};
  }
}
</script>

<style lang="scss"></style>
